########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################


#     
bind dcc -|- reload 	::ymhuk::reload

#  
bind dcc -|- useradd 	::ymhuk::add.user

# xtra  
bind dcc -|- userset	::ymhuk::settings.user

#   
bind dcc -|- userdel 	::ymhuk::del.user

bind dcc -|- scoreadd 	::ymhuk::add.score

#  ( $conf(perm.users))
bind dcc -|- clear 		::ymhuk::clear.base

#    (,      )
bind dcc -|- idleset	::ymhuk::set.idle

bind dcc -|- backup	::ymhuk::admin.backup

proc ::ymhuk::admin.backup {handle idx text} {
	::ymhuk::back.up.base 0 0 0 0 0
}

proc ::ymhuk::reload {handle idx text} {
	variable conf
	putlog "Clearing userbase..."
	foreach user [userlist] {
		set no_del 0
		foreach perm_user [split $conf(perm.users) ","] {
			if {$user == $perm_user} {	
				setuser $user xtra ymhuk ""
				set no_del 1
				break
			}
		}
		if {$no_del == 0} {deluser $user}
	}
	putlog "Cleared."
	putlog "Reloading..."
	set f [open $conf(back.up.base) r]
	fconfigure $f -encoding "binary"
	set users [read $f]
	close $f
	foreach item [split $users "\n"] {
		if {$item == ""} {continue}
		set item 			[split $item "*"]
		set user 			[join [lindex [split [lindex $item 0] ":"] 1]]
		set score 			[join [lindex [split [lindex $item 1] ":"] 1]]
		set answers			[join [lindex [split [lindex $item 2] ":"] 1]]
		set answer_chain 		[join [lindex [split [lindex $item 3] ":"] 1]]
		set seconds 		[join [lindex [split [lindex $item 4] ":"] 1]]
		set sex 			[join [lindex [split [lindex $item 5] ":"] 1]]
		set news 			[join [lindex [split [lindex $item 6] ":"] 1]]
		set idle 			[join [lindex [split [lindex $item 7] ":"] 1]]
		set remort 			[join [lindex [split [lindex $item 8] ":"] 1]]
		set title			[join [lindex [split [lindex $item 9] ":"] 1]]
		if {![validuser $user]} {
			adduser $user *!*@*
		}
		setuser $user xtra ymhuk "$score $answers $answer_chain $seconds"
		if {$idle != "no"} 		{ setuser $user xtra idle $idle } else { setuser $user xtra idle [clock seconds] }
		if {$news != "no"} 		{ setuser $user xtra news $news }
		if {$remort != "no"}	{ setuser $user xtra remort $remort }
		if {$title != "no"}		{ setuser $user xtra title $title }
		switch "$sex" {
			m {	setuser $user xtra sex m }
			w {	setuser $user xtra sex w }
			default { setuser $user xtra sex o }
		}
	}
	putlog "Reloaded"
	return
}

proc ::ymhuk::add.user {handle idx text} {
	set user [lindex $text 0]
	set points [lrange $text 1 end]
	if {[validuser $user]} {
		putlog "   !"
		return
	} 
	adduser $user *!*@*
	setuser $user xtra idle [clock seconds]
	setuser $user xtra ymhuk $points
	putlog "  $user  : $points"
	return
}

proc ::ymhuk::settings.user {handle idx text} {
	set user 	[lindex $text 0]
	set field	[lindex $text 1]
	set value	[lrange $text 2 end]
	if {![validuser $user]} {
		putlog "  !"
		return
	} 
	setuser $user xtra $field $value
	putlog "  $field   $value   $user"
	return
}

proc ::ymhuk::del.user {handle idx text} {
	if {![validuser $text]} {
		putlog "  !"
		return
	} 
	deluser $text
	putlog " $text !"
	return
}

proc ::ymhuk::add.score {handle idx text} {
	set user [join [lindex [split $text " "] 0]]
	if {![validuser $user]} {
		putlog "  !"
		return
	} 
	set score_add [join [lindex [split $text " "] 1]]
	setuser $user xtra ymhuk "[expr $score_add + [::ymhuk::get.score $user]] [::ymhuk::get.answers $user] [::ymhuk::get.answer.chain $user] [::ymhuk::get.seconds $user]"
	putlog "  $user  $score_add "
	return
}

proc ::ymhuk::clear.base {handle idx text} {
	variable conf
	putlog "Clearing userbase..."
	foreach user [userlist] {
		set no_del 0
		foreach perm_user [split $conf(perm.users) ","] {
			if {$user == $perm_user} {	
				setuser $user xtra ymhuk ""
				setuser $user xtra idle ""
				set no_del 1
				break
			}
		}
		if {$no_del == 0} {deluser $user}
	}
	putlog "Cleared."
	return
}

proc ::ymhuk::set.idle {handle idx text} {
	putlog "Setting current time..."
	foreach user [userlist] {
		if {[getuser $user xtra ymhuk] == ""} {continue}
		if {[getuser $user xtra idle] != ""} {continue}
		setuser $user xtra idle [clock seconds]
	}
	putlog "Idle-time was set for each user."
	return
}

putlog "yMHuk: Administration script loaded"