########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################


#  
bind pub -|- !		::ymhuk::news.pub
bind pub -|- !			::ymhuk::news.pub
bind pub -|- !yjdjcnb		::ymhuk::news.pub
bind pub -|- !news			::ymhuk::news.pub

# 
bind msg -|- !	 	::ymhuk::news.read
bind pub -|- !yjdjcnb		::ymhuk::news.read
bind msg -|- !new	 		::ymhuk::news.read
bind msg -|- ! 			::ymhuk::news.read

# ()
bind pub -|- !		::ymhuk::news.add.pub
bind pub -|- !newsadd		::ymhuk::news.add.pub

# ()
bind msg -|- !		::ymhuk::news.add.msg
bind msg -|- !newsadd		::ymhuk::news.add.msg

# ()
bind pub -|- !		::ymhuk::news.del.pub
bind pub -|- !newsdel		::ymhuk::news.del.pub

# ()
bind msg -|- !		::ymhuk::news.del.msg
bind msg -|- !newsdel		::ymhuk::news.del.msg

# - 
proc ::ymhuk::news.count {} {
	variable conf
	set news [open $conf(news.base) r]
	fconfigure $news -encoding "binary"
	set news_length [llength [split [read $news] "\n"]]
	close $news
	return $news_length
}

#     
proc ::ymhuk::news.on.join {nick} {
	set news_count [expr [::ymhuk::news.count] - 1]
	if {(![validuser $nick]) || ($news_count == 0)} {return}
	if {[getuser $nick xtra news] >= $news_count} {
		setuser $nick xtra news $news_count
		return
	}
	if {[getuser $nick xtra news] == ""} {
		::ymhuk::priv.msg $nick "\00310  \0033 $news_count\00310 [lindex {{0} { } { } { }} [::ymhuk::check.number $news_count]]!       ."
		::ymhuk::priv.msg $nick "\00310  \0033 ! <>\00310    .  ! 3.    :\0033 $news_count\00310."
		return
	}
	if {[getuser $nick xtra news] != ""} {
		::ymhuk::priv.msg $nick "\00310  \0033 [expr $news_count - [getuser $nick xtra news]]\00310 [lindex {{0} { } { } { }} [::ymhuk::check.number [expr $news_count - [getuser $nick xtra news]]]]!    :   \0033 [getuser $nick xtra news]\00310."
		::ymhuk::priv.msg $nick "\00310  \0033 ! <>\00310    .  ! 3.    :\0033 $news_count\00310."
		return
	}
	return
}

# 
proc ::ymhuk::news.read {nick uhost handle text} {
	variable conf
	if {![validuser $nick]} {
		::ymhuk::priv.msg $nick "\00310   ,    !"
		return
	}
	if {($text < 1) || ($text > [expr [::ymhuk::news.count] - 1]) || ($text == "")} {
		::ymhuk::priv.msg $nick "\00310  !   \0033 [expr [::ymhuk::news.count] - 1]\00310.  \0033 ! <>\00310.  ! 3." 
		return
	}
	set news [open $conf(news.base) r]
	fconfigure $news -encoding "binary"
	set new [lindex [split [read $news] "\n"] [expr $text - 1]]
	close $news
	set new [split $new "&"]
	set date [lindex $new 0]
	set line_new [lindex $new 1]
	set nick_new [lindex $new 2]
	if {[getuser $nick xtra news] < $text} {
		setuser $nick xtra news $text
	}
	::ymhuk::priv.msg $nick "\0033 $text.\0037 $date.\00310 $line_new \0033() $nick_new."	
	return
}

# 
proc ::ymhuk::news.add.pub {nick uhost handle chan text} {
	variable conf; variable ymhuk
	if {$chan != $conf(chan)} {
		return
	}
	if {![isop $nick $chan]} {
		::ymhuk::pub.msg "\00310, $nick,      ." 
		return
	}
	set ymhuk(news.add.msg) 0
	::ymhuk::news.add $nick $uhost $handle $chan $text
	return
}

# 
proc ::ymhuk::news.add.msg {nick uhost handle text} {
	variable conf; variable ymhuk
	if {![isop $nick $conf(chan)]} {
		::ymhuk::priv.msg $nick "\00310     $conf(chan)." 
		return
	}
	set ymhuk(news.add.msg) 1
	::ymhuk::news.add $nick $uhost $handle 0 $text
	return
}

# 
proc ::ymhuk::news.add {nick uhost handle chan text} {
	variable conf; variable ymhuk
	set news [open $conf(news.base) a]
	fconfigure $news -encoding "binary"
	puts $news "[strftime "%d %h %Y" [unixtime]]&$text&$nick"
	close $news
	if {$conf(show.new.news) == 1} {
		foreach user [chanlist $conf(chan)] {
			if {([string match $user $nick]) || ([isbotnick $user])} {continue}
			::ymhuk::priv.msg $user "\00310    \0033 [expr [::ymhuk::news.count] - 1]\00310.   \0033 ! [expr [::ymhuk::news.count] - 1]\00310  ."
		}
	}
	switch $ymhuk(news.add.msg) {
	1 { ::ymhuk::priv.msg $nick "\00310 [expr [::ymhuk::news.count] - 1] ." }
	0 {	::ymhuk::pub.msg "\00310 [expr [::ymhuk::news.count] - 1] ." }
	}
	return
}

# 
proc ::ymhuk::news.del.pub {nick uhost handle chan text} {
	variable conf; variable ymhuk
		if {$chan != $conf(chan)} {
		return
	}
	if {![isop $nick $chan]} {
		::ymhuk::pub.msg "\00310, $nick,      ." 
		return
	}
	if {($text > [expr [::ymhuk::news.count] - 1]) || ($text < 1)} {
		::ymhuk::pub.msg "\00310  .    [expr [::ymhuk::news.count] - 1]." 
		return
	}
	set ymhuk(news.del.msg) 0
	::ymhuk::news.del $nick $uhost $handle $chan $text
	return
}

# 
proc ::ymhuk::news.del.msg {nick uhost handle text} {
	variable conf; variable ymhuk
	if {![isop $nick $conf(chan)]} {
		::ymhuk::priv.msg $nick "\00310, $nick,      $conf(chan)." 
		return
	}
	if {($text > [expr [::ymhuk::news.count] - 1]) || ($text < 1)} {
		::ymhuk::priv.msg "\00310  .    [expr [::ymhuk::news.count] - 1]." 
		return
	}
	set ymhuk(news.del.msg) 1
	::ymhuk::news.del $nick $uhost $handle 0 $text
	return
}

# 
proc ::ymhuk::news.del {nick uhost handle chan text} {
	variable conf; variable ymhuk
	set news [open $conf(news.base) r]
	fconfigure $news -encoding "binary"
	set lst [split [read $news] "\n"]
	close $news
	set lst [lreplace $lst [expr $text - 1] [expr $text - 1]]
	set news [open $conf(news.base) w+]
	fconfigure $news -encoding "binary"
	foreach item $lst {
		if {![llength $item]} {continue} else {puts $news "$item"}
	}
	close $news
	switch $ymhuk(news.del.msg) {
		1 { ::ymhuk::priv.msg $nick "\00310 $text ." }
		0 {	::ymhuk::pub.msg "\00310 $text ." }	
	}
	return
}

#   
proc ::ymhuk::news.pub {nick uhost handle chan text} {
	variable conf
		variable conf; variable ymhuk
		if {$chan != $conf(chan)} {
		return
	}
	::ymhuk::pub.msg "\00310   :\0033 [expr [::ymhuk::news.count] - 1]\00310.      \0033 ! <> \00310 .  ! 3."
	return
}

putlog "yMHuk: News script loaded"